/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';

/**
 * The Profit model module.
 * @module model/Profit
 * @version 2021.12-dev21
 */
class Profit {
    /**
     * Constructs a new <code>Profit</code>.
     * @alias module:model/Profit
     * @param profitClosedCoin {Number} 
     * @param profitClosedPercentMean {Number} 
     * @param profitClosedRatioMean {Number} 
     * @param profitClosedPercentSum {Number} 
     * @param profitClosedRatioSum {Number} 
     * @param profitClosedPercent {Number} 
     * @param profitClosedRatio {Number} 
     * @param profitClosedFiat {Number} 
     * @param profitAllCoin {Number} 
     * @param profitAllPercentMean {Number} 
     * @param profitAllRatioMean {Number} 
     * @param profitAllPercentSum {Number} 
     * @param profitAllRatioSum {Number} 
     * @param profitAllPercent {Number} 
     * @param profitAllRatio {Number} 
     * @param profitAllFiat {Number} 
     * @param tradeCount {Number} 
     * @param closedTradeCount {Number} 
     * @param firstTradeDate {String} 
     * @param firstTradeTimestamp {Number} 
     * @param latestTradeDate {String} 
     * @param latestTradeTimestamp {Number} 
     * @param avgDuration {String} 
     * @param bestPair {String} 
     * @param bestRate {Number} 
     * @param bestPairProfitRatio {Number} 
     * @param winningTrades {Number} 
     * @param losingTrades {Number} 
     */
    constructor(profitClosedCoin, profitClosedPercentMean, profitClosedRatioMean, profitClosedPercentSum, profitClosedRatioSum, profitClosedPercent, profitClosedRatio, profitClosedFiat, profitAllCoin, profitAllPercentMean, profitAllRatioMean, profitAllPercentSum, profitAllRatioSum, profitAllPercent, profitAllRatio, profitAllFiat, tradeCount, closedTradeCount, firstTradeDate, firstTradeTimestamp, latestTradeDate, latestTradeTimestamp, avgDuration, bestPair, bestRate, bestPairProfitRatio, winningTrades, losingTrades) { 
        
        Profit.initialize(this, profitClosedCoin, profitClosedPercentMean, profitClosedRatioMean, profitClosedPercentSum, profitClosedRatioSum, profitClosedPercent, profitClosedRatio, profitClosedFiat, profitAllCoin, profitAllPercentMean, profitAllRatioMean, profitAllPercentSum, profitAllRatioSum, profitAllPercent, profitAllRatio, profitAllFiat, tradeCount, closedTradeCount, firstTradeDate, firstTradeTimestamp, latestTradeDate, latestTradeTimestamp, avgDuration, bestPair, bestRate, bestPairProfitRatio, winningTrades, losingTrades);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, profitClosedCoin, profitClosedPercentMean, profitClosedRatioMean, profitClosedPercentSum, profitClosedRatioSum, profitClosedPercent, profitClosedRatio, profitClosedFiat, profitAllCoin, profitAllPercentMean, profitAllRatioMean, profitAllPercentSum, profitAllRatioSum, profitAllPercent, profitAllRatio, profitAllFiat, tradeCount, closedTradeCount, firstTradeDate, firstTradeTimestamp, latestTradeDate, latestTradeTimestamp, avgDuration, bestPair, bestRate, bestPairProfitRatio, winningTrades, losingTrades) { 
        obj['profit_closed_coin'] = profitClosedCoin;
        obj['profit_closed_percent_mean'] = profitClosedPercentMean;
        obj['profit_closed_ratio_mean'] = profitClosedRatioMean;
        obj['profit_closed_percent_sum'] = profitClosedPercentSum;
        obj['profit_closed_ratio_sum'] = profitClosedRatioSum;
        obj['profit_closed_percent'] = profitClosedPercent;
        obj['profit_closed_ratio'] = profitClosedRatio;
        obj['profit_closed_fiat'] = profitClosedFiat;
        obj['profit_all_coin'] = profitAllCoin;
        obj['profit_all_percent_mean'] = profitAllPercentMean;
        obj['profit_all_ratio_mean'] = profitAllRatioMean;
        obj['profit_all_percent_sum'] = profitAllPercentSum;
        obj['profit_all_ratio_sum'] = profitAllRatioSum;
        obj['profit_all_percent'] = profitAllPercent;
        obj['profit_all_ratio'] = profitAllRatio;
        obj['profit_all_fiat'] = profitAllFiat;
        obj['trade_count'] = tradeCount;
        obj['closed_trade_count'] = closedTradeCount;
        obj['first_trade_date'] = firstTradeDate;
        obj['first_trade_timestamp'] = firstTradeTimestamp;
        obj['latest_trade_date'] = latestTradeDate;
        obj['latest_trade_timestamp'] = latestTradeTimestamp;
        obj['avg_duration'] = avgDuration;
        obj['best_pair'] = bestPair;
        obj['best_rate'] = bestRate;
        obj['best_pair_profit_ratio'] = bestPairProfitRatio;
        obj['winning_trades'] = winningTrades;
        obj['losing_trades'] = losingTrades;
    }

    /**
     * Constructs a <code>Profit</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/Profit} obj Optional instance to populate.
     * @return {module:model/Profit} The populated <code>Profit</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new Profit();

            if (data.hasOwnProperty('profit_closed_coin')) {
                obj['profit_closed_coin'] = ApiClient.convertToType(data['profit_closed_coin'], 'Number');
            }
            if (data.hasOwnProperty('profit_closed_percent_mean')) {
                obj['profit_closed_percent_mean'] = ApiClient.convertToType(data['profit_closed_percent_mean'], 'Number');
            }
            if (data.hasOwnProperty('profit_closed_ratio_mean')) {
                obj['profit_closed_ratio_mean'] = ApiClient.convertToType(data['profit_closed_ratio_mean'], 'Number');
            }
            if (data.hasOwnProperty('profit_closed_percent_sum')) {
                obj['profit_closed_percent_sum'] = ApiClient.convertToType(data['profit_closed_percent_sum'], 'Number');
            }
            if (data.hasOwnProperty('profit_closed_ratio_sum')) {
                obj['profit_closed_ratio_sum'] = ApiClient.convertToType(data['profit_closed_ratio_sum'], 'Number');
            }
            if (data.hasOwnProperty('profit_closed_percent')) {
                obj['profit_closed_percent'] = ApiClient.convertToType(data['profit_closed_percent'], 'Number');
            }
            if (data.hasOwnProperty('profit_closed_ratio')) {
                obj['profit_closed_ratio'] = ApiClient.convertToType(data['profit_closed_ratio'], 'Number');
            }
            if (data.hasOwnProperty('profit_closed_fiat')) {
                obj['profit_closed_fiat'] = ApiClient.convertToType(data['profit_closed_fiat'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_coin')) {
                obj['profit_all_coin'] = ApiClient.convertToType(data['profit_all_coin'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_percent_mean')) {
                obj['profit_all_percent_mean'] = ApiClient.convertToType(data['profit_all_percent_mean'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_ratio_mean')) {
                obj['profit_all_ratio_mean'] = ApiClient.convertToType(data['profit_all_ratio_mean'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_percent_sum')) {
                obj['profit_all_percent_sum'] = ApiClient.convertToType(data['profit_all_percent_sum'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_ratio_sum')) {
                obj['profit_all_ratio_sum'] = ApiClient.convertToType(data['profit_all_ratio_sum'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_percent')) {
                obj['profit_all_percent'] = ApiClient.convertToType(data['profit_all_percent'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_ratio')) {
                obj['profit_all_ratio'] = ApiClient.convertToType(data['profit_all_ratio'], 'Number');
            }
            if (data.hasOwnProperty('profit_all_fiat')) {
                obj['profit_all_fiat'] = ApiClient.convertToType(data['profit_all_fiat'], 'Number');
            }
            if (data.hasOwnProperty('trade_count')) {
                obj['trade_count'] = ApiClient.convertToType(data['trade_count'], 'Number');
            }
            if (data.hasOwnProperty('closed_trade_count')) {
                obj['closed_trade_count'] = ApiClient.convertToType(data['closed_trade_count'], 'Number');
            }
            if (data.hasOwnProperty('first_trade_date')) {
                obj['first_trade_date'] = ApiClient.convertToType(data['first_trade_date'], 'String');
            }
            if (data.hasOwnProperty('first_trade_timestamp')) {
                obj['first_trade_timestamp'] = ApiClient.convertToType(data['first_trade_timestamp'], 'Number');
            }
            if (data.hasOwnProperty('latest_trade_date')) {
                obj['latest_trade_date'] = ApiClient.convertToType(data['latest_trade_date'], 'String');
            }
            if (data.hasOwnProperty('latest_trade_timestamp')) {
                obj['latest_trade_timestamp'] = ApiClient.convertToType(data['latest_trade_timestamp'], 'Number');
            }
            if (data.hasOwnProperty('avg_duration')) {
                obj['avg_duration'] = ApiClient.convertToType(data['avg_duration'], 'String');
            }
            if (data.hasOwnProperty('best_pair')) {
                obj['best_pair'] = ApiClient.convertToType(data['best_pair'], 'String');
            }
            if (data.hasOwnProperty('best_rate')) {
                obj['best_rate'] = ApiClient.convertToType(data['best_rate'], 'Number');
            }
            if (data.hasOwnProperty('best_pair_profit_ratio')) {
                obj['best_pair_profit_ratio'] = ApiClient.convertToType(data['best_pair_profit_ratio'], 'Number');
            }
            if (data.hasOwnProperty('winning_trades')) {
                obj['winning_trades'] = ApiClient.convertToType(data['winning_trades'], 'Number');
            }
            if (data.hasOwnProperty('losing_trades')) {
                obj['losing_trades'] = ApiClient.convertToType(data['losing_trades'], 'Number');
            }
        }
        return obj;
    }


}

/**
 * @member {Number} profit_closed_coin
 */
Profit.prototype['profit_closed_coin'] = undefined;

/**
 * @member {Number} profit_closed_percent_mean
 */
Profit.prototype['profit_closed_percent_mean'] = undefined;

/**
 * @member {Number} profit_closed_ratio_mean
 */
Profit.prototype['profit_closed_ratio_mean'] = undefined;

/**
 * @member {Number} profit_closed_percent_sum
 */
Profit.prototype['profit_closed_percent_sum'] = undefined;

/**
 * @member {Number} profit_closed_ratio_sum
 */
Profit.prototype['profit_closed_ratio_sum'] = undefined;

/**
 * @member {Number} profit_closed_percent
 */
Profit.prototype['profit_closed_percent'] = undefined;

/**
 * @member {Number} profit_closed_ratio
 */
Profit.prototype['profit_closed_ratio'] = undefined;

/**
 * @member {Number} profit_closed_fiat
 */
Profit.prototype['profit_closed_fiat'] = undefined;

/**
 * @member {Number} profit_all_coin
 */
Profit.prototype['profit_all_coin'] = undefined;

/**
 * @member {Number} profit_all_percent_mean
 */
Profit.prototype['profit_all_percent_mean'] = undefined;

/**
 * @member {Number} profit_all_ratio_mean
 */
Profit.prototype['profit_all_ratio_mean'] = undefined;

/**
 * @member {Number} profit_all_percent_sum
 */
Profit.prototype['profit_all_percent_sum'] = undefined;

/**
 * @member {Number} profit_all_ratio_sum
 */
Profit.prototype['profit_all_ratio_sum'] = undefined;

/**
 * @member {Number} profit_all_percent
 */
Profit.prototype['profit_all_percent'] = undefined;

/**
 * @member {Number} profit_all_ratio
 */
Profit.prototype['profit_all_ratio'] = undefined;

/**
 * @member {Number} profit_all_fiat
 */
Profit.prototype['profit_all_fiat'] = undefined;

/**
 * @member {Number} trade_count
 */
Profit.prototype['trade_count'] = undefined;

/**
 * @member {Number} closed_trade_count
 */
Profit.prototype['closed_trade_count'] = undefined;

/**
 * @member {String} first_trade_date
 */
Profit.prototype['first_trade_date'] = undefined;

/**
 * @member {Number} first_trade_timestamp
 */
Profit.prototype['first_trade_timestamp'] = undefined;

/**
 * @member {String} latest_trade_date
 */
Profit.prototype['latest_trade_date'] = undefined;

/**
 * @member {Number} latest_trade_timestamp
 */
Profit.prototype['latest_trade_timestamp'] = undefined;

/**
 * @member {String} avg_duration
 */
Profit.prototype['avg_duration'] = undefined;

/**
 * @member {String} best_pair
 */
Profit.prototype['best_pair'] = undefined;

/**
 * @member {Number} best_rate
 */
Profit.prototype['best_rate'] = undefined;

/**
 * @member {Number} best_pair_profit_ratio
 */
Profit.prototype['best_pair_profit_ratio'] = undefined;

/**
 * @member {Number} winning_trades
 */
Profit.prototype['winning_trades'] = undefined;

/**
 * @member {Number} losing_trades
 */
Profit.prototype['losing_trades'] = undefined;






export default Profit;

